/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/LabelEnablement'],function(q,l,C,E,L){"use strict";var a=C.extend("sap.ui.commons.Link",{metadata:{interfaces:["sap.ui.commons.ToolbarItem","sap.ui.commons.FormattedTextViewControl"],library:"sap.ui.commons",properties:{text:{type:"string",group:"Appearance",defaultValue:''},enabled:{type:"boolean",group:"Behavior",defaultValue:true},helpId:{type:"string",group:"Behavior",defaultValue:''},href:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},target:{type:"string",group:"Data",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{allowPreventDefault:true}}}});E.call(a.prototype);a.prototype.onBeforeRendering=function(){this.removeAssociation("ariaLabelledBy",this.getId(),true);if(this.getAriaLabelledBy().length>0||L.getReferencingLabels(this).length>0){this.addAssociation("ariaLabelledBy",this.getId(),true);}};a.prototype.onsapspace=function(e){a.prototype.onclick.apply(this,arguments);};a.prototype.onclick=function(e){if(this.getEnabled()){if(!this.firePress()||!this.getHref()){e.preventDefault();}}else{e.preventDefault();}};a.prototype.onsapenter=function(e){e.stopPropagation();};a.prototype.getAccessibilityInfo=function(){return{role:"link",type:sap.ui.getCore().getLibraryResourceBundle("sap.ui.commons").getText("ACC_CTR_TYPE_LINK"),description:this.getText()||this.getHref()||"",focusable:this.getEnabled(),enabled:this.getEnabled()};};return a;},true);
